# Задачи к экзамену по мдк 01.04 - Системное программирование

### Базовые задачи

> Создание консольной утилиты, которая печатает список переданных ей аргументов из командной строки. При демонстрации работы программы рассмотреть не менее трех способов передачи аргументов в запускаемый процесс

> Программа для преобразования числа в строку и склейки двух строк. Разработать без использования системных функций

> Программа для преобразования строки в число. Строка хранится в виде указателя LPWSTR. Реализовать без использования системных функций

> Программа для считывания нескольких числовых значений из строки и из записи в числовой массив (разделитель - пробел). Количество значений в строке заранее неизвестно.

> Использование условных блоков для анализа значений, возвращаемых системной функцией (не менее трех функций для каждой ОС)


### Указатели

> Создание линейного односвязного списка из n элементов. Значение элемента генерируется случайным образом. Поместить в отдельные указатели адрес минимального и максимального элемента списка. Вывести список и значения минимального и максимального элемента через указатель.

> Создание функции, аргументом которой является указатель на функцию. Создать не менее двух вспомогательных функций и передать их в качестве аргумента исходной функции. Продемонстрировать специфику работы исходной функции в зависимости от переданных параметров


### Файлы

> Программа для считывания и записи строкового значения из текстового файла с последующей записью его в другой текстовый файл. Для работы с файлами используются функции WinAPI.

> Создание и настройка проекта WinAPI. Вывод сообщения в messagebox. Текст сообщения считывается из текстового файла в кодировке Юникод 

> Программа для считывания числового значения из файла (с сохранением его в числовом формате). Исходный файл является бинарным


### Потоки

> Разработка программы-секундомера. в одном потоке идет отсчет времени, а в другом осуществляется управление секундомером

> Создание программы с критической секцией в ОС Windows. Программа должна содержать минимум два потока. Использование критической секции в функции потока должно быть обосновано.

> Разработка программы для вычисления факториала в отдельном потоке. В программе должна быть предусмотрена валидация данных.


### Процессы

> Программа с запуском стороннего процесса исполняемый файл стороннего процесса подготавливается заранее.

> Создание фонового процесса, который каждые 5 секунд выводит всплывающее или диалоговое сообщение, содержащее увеличивающееся на единицу значение счетчика.


### Библиотеки

> Создание и отладка библиотеки DLL. Для демонстрации работы написать две элементарные функции в библиотеке и вызвать их из основной программы.

> Программа с импортом функции из файла DLL. Функция принимает  структуру, содержащую координаты двух точек, а возвращает длину отрезка, который образуется этими точками.


### Каналы 

> Отправка и получение данных из именованного канала. Данные содержатся в строковой форме. Перед отправкой следующей строки клиенту необходимо дождаться ответа от сервера.

> Использование анонимного канала для передачи строковых значений между процессами


### Буфер

> Использование системного буфера обмена для передачи строковых значений между процессами.

> Программа для записи и считывание строки с использованием системного буфера. 


### Клавиши

> Обработка нажатия клавиши мыши в системе (выписать в messagebox какая клавиша нажата и сколько раз)

> Получение названия клавиши с использованием функции GetKeyNameText (Windows HOOK). Название клавиши выводить в MessageBox

> Получение кода клавиши в формате ASCII и использованием Windows HOOK. Название клавиши выводить в MessageBox


### Реестр

> Запись и считывание строковых параметров в системный реестр.

> Запись и считывание числовых параметров в системный реестр
